	jp _SKIPOVERNOTEMAN
; Inputs: HL (location of song)
playSong:
	ld a, (hl)
	sub 48
	ld b, a
	ld a, 0
	
	add a, b
	add a, b
	add a, b
	add a, b
	add a, b
	add a, b
	add a, b
	add a, b
	add a, b
	add a, b
	
	ld (looptimes), a
	
	inc hl
	ld a, (hl)
	sub 48
	ld b, a
	ld a, (looptimes)
	add a, b
	ld (looptimes), a
	
	inc hl
	
	ld a, (looptimes)
	cp 0
	call z, setRests

	ld a, (hl)
	cp 'R'
	call z, Rests

	ld a, (hl)
	cp 'C'
	call z, CNotes
	ld a, (hl)
	cp 'D'
	call z, DNotes
	ld a, (hl)
	cp 'E'
	call z, ENotes
	ld a, (hl)
	cp 'F'
	call z, FNotes
	cp 'G'
	call z, GNotes
	ld a, (hl)
	cp 'A'
	call z, ANotes
	ld a, (hl)
	cp 'B'
	call z, BNotes

	ld a, (hl)
	cp 'c'
	call z, cNotes
	ld a, (hl)
	cp 'd'
	call z, dNotes
	ld a, (hl)
	cp 'e'
	call z, eNotes
	ld a, (hl)
	cp 'f'
	call z, fNotes
	ld a, (hl)
	cp 'g'
	call z, gNotes
	ld a, (hl)
	cp 'a'
	call z, aNotes
	ld a, (hl)
	cp 'b'
	call z, bNotes

	ld a, (hl)
	cp 178
	call z, cNotes
	ld a, (hl)
	cp 179
	call z, dNotes
	ld a, (hl)
	cp 180
	call z, eNotes
	ld a, (hl)
	cp 181
	call z, fNotes
	ld a, (hl)
	cp 182
	call z, gNotes
	ld a, (hl)
	cp 176
	call z, aNotes
	ld a, (hl)
	cp 177
	call z, bNotes
	
	push hl
	ld hl, 1000
	call pause
	pop hl
	
	ld a, (hl)
	cp 0
	ret z
	jp playSong
	
setRests:
	ld a, 1
	ld (looptimes), a
	ld a, 'R'	
	ld (hl), a
	ret

Rests:
	inc hl
RestsLoop:
	push hl
	call Rest
	pop hl

	ld a, (looptimes)
	dec a
	cp 0
	ret z
	ld (looptimes), a
	
	jp RestsLoop
	ret

CNotes:
	inc hl
CNotesLoop:
	ld a, (hl)
	cp '0'
	push hl
	call z, playC0
	pop hl

	ld a, (hl)
	cp '1'
	push hl
	call z, playC1
	pop hl

	ld a, (hl)
	cp '2'
	push hl
	call z, playC2
	pop hl
	
	ld a, (hl)
	cp '3'
	push hl
	call z, playC3
	pop hl
	
	ld a, (looptimes)
	dec a
	cp 0
	ret z
	ld (looptimes), a
	
	jp CNotesLoop
	ret

DNotes:
	inc hl
DNotesLoop:
	ld a, (hl)
	cp '0'
	push hl
	call z, playD0
	pop hl

	ld a, (hl)
	cp '1'
	push hl
	call z, playD1
	pop hl

	ld a, (hl)
	cp '2'
	push hl
	call z, playD2
	pop hl

	ld a, (hl)
	cp '3'
	push hl
	call z, playD3
	pop hl
	
	ld a, (looptimes)
	dec a
	cp 0
	ret z
	ld (looptimes), a
	
	jp DNotesLoop
	ret

ENotes:
	inc hl
ENotesLoop:
	ld a, (hl)
	cp '0'
	push hl
	call z, playE0
	pop hl

	ld a, (hl)
	cp '1'
	push hl
	call z, playE1
	pop hl

	ld a, (hl)
	cp '2'
	push hl
	call z, playE2
	pop hl
	
	ld a, (hl)
	cp '3'
	push hl
	call z, playE3
	pop hl
	
	ld a, (looptimes)
	dec a
	cp 0
	ret z
	ld (looptimes), a
	
	jp ENotesLoop
	ret

FNotes:
	inc hl
FNotesLoop:
	ld a, (hl)
	cp '0'
	push hl
	call z, playF0
	pop hl

	ld a, (hl)
	cp '1'
	push hl
	call z, playF1
	pop hl

	ld a, (hl)
	cp '2'
	push hl
	call z, playF2
	pop hl
	
	ld a, (hl)
	cp '3'
	push hl
	call z, playF3
	pop hl
	


	ld a, (looptimes)
	dec a
	cp 0
	ret z
	ld (looptimes), a
	
	jp FNotesLoop
	ret

GNotes:
	inc hl
GNotesLoop:
	ld a, (hl)
	cp '0'
	push hl
	call z, playG0
	pop hl

	ld a, (hl)
	cp '1'
	push hl
	call z, playG1
	pop hl

	ld a, (hl)
	cp '2'
	push hl
	call z, playG2
	pop hl
	
	ld a, (hl)
	cp '3'
	push hl
	call z, playG3
	pop hl
	
	ld a, (looptimes)
	dec a
	cp 0
	ret z
	ld (looptimes), a
	
	jp GNotesLoop
	ret

ANotes:
	inc hl
ANotesLoop:
	ld a, (hl)
	cp '0'
	push hl
	call z, playA0
	pop hl

	ld a, (hl)
	cp '1'
	push hl
	call z, playA1
	pop hl

	ld a, (hl)
	cp '2'
	push hl
	call z, playA2
	pop hl
	
	ld a, (hl)
	cp '3'
	push hl
	call z, playA3
	pop hl
	
	ld a, (looptimes)
	dec a
	cp 0
	ret z
	ld (looptimes), a
	
	jp ANotesLoop
	ret

BNotes:
	inc hl
BNotesLoop:
	ld a, (hl)
	cp '0'
	push hl
	call z, playB0
	pop hl
	
	ld a, (hl)
	cp '1'
	push hl
	call z, playB1
	pop hl
	
	ld a, (hl)
	cp '2'
	push hl
	call z, playB2
	pop hl
	
	ld a, (hl)
	cp '2'
	push hl
	call z, playB3
	pop hl
	
	ld a, (looptimes)
	dec a
	cp 0
	ret z
	ld (looptimes), a
	
	jp BNotesLoop
	ret

cNotes:
	inc hl
cNotesLoop:

	ld a, (hl)
	cp '1'
	push hl
	call z, playC1b
	pop hl

	ld a, (hl)
	cp '2'
	push hl
	call z, playC2b
	pop hl
	
	ld a, (hl)
	cp '3'
	push hl
	call z, playC3b
	pop hl
	
	ld a, (looptimes)
	dec a
	cp 0
	ret z
	ld (looptimes), a
	
	jp cNotesLoop
	ret

dNotes:
	inc hl
dNotesLoop:
	ld a, (hl)
	cp '0'
	push hl
	call z, playD0b
	pop hl

	ld a, (hl)
	cp '1'
	push hl
	call z, playD1b
	pop hl

	ld a, (hl)
	cp '2'
	push hl
	call z, playD2b
	pop hl
	
	ld a, (hl)
	cp '3'
	push hl
	call z, playD3b
	pop hl
	
	ld a, (looptimes)
	dec a
	cp 0
	ret z
	ld (looptimes), a
	
	jp dNotesLoop
	ret

eNotes:
	inc hl
eNotesLoop:
	ld a, (hl)
	cp '0'
	push hl
	call z, playE0b
	pop hl

	ld a, (hl)
	cp '1'
	push hl
	call z, playE1b
	pop hl

	ld a, (hl)
	cp '2'
	push hl
	call z, playE2b
	pop hl
	
	ld a, (hl)
	cp '3'
	push hl
	call z, playE3b
	pop hl
	
	ld a, (looptimes)
	dec a
	cp 0
	ret z
	ld (looptimes), a
	
	jp eNotesLoop
	ret


fNotes:
	inc hl
fNotesLoop:
	ld a, (hl)
	cp '0'
	push hl
	call z, playF0b
	pop hl

	ld a, (hl)
	cp '1'
	push hl
	call z, playF1b
	pop hl

	ld a, (hl)
	cp '2'
	push hl
	call z, playF2b
	pop hl

	ld a, (hl)
	cp '3'
	push hl
	call z, playF3b
	pop hl
	
	ld a, (looptimes)
	dec a
	cp 0
	ret z
	ld (looptimes), a
	
	jp fNotesLoop
	ret


gNotes:
	inc hl
gNotesLoop:
	ld a, (hl)
	cp '0'
	push hl
	call z, playG0b
	pop hl

	ld a, (hl)
	cp '1'
	push hl
	call z, playG1b
	pop hl

	ld a, (hl)
	cp '2'
	push hl
	call z, playG2b
	pop hl
	
	ld a, (hl)
	cp '3'
	push hl
	call z, playG3b
	pop hl
	
	ld a, (looptimes)
	dec a
	cp 0
	ret z
	ld (looptimes), a
	
	jp gNotesLoop
	ret


aNotes:
	inc hl
aNotesLoop:
	ld a, (hl)
	cp '0'
	push hl
	call z, playA0b
	pop hl

	ld a, (hl)
	cp '1'
	push hl
	call z, playA1b
	pop hl

	ld a, (hl)
	cp '2'
	push hl
	call z, playA2b
	pop hl
	
	ld a, (hl)
	cp '3'
	push hl
	call z, playA3b
	pop hl
	
	ld a, (looptimes)
	dec a
	cp 0
	ret z
	ld (looptimes), a
	
	jp aNotesLoop
	ret

bNotes:
	inc hl
bNotesLoop:
	ld a, (hl)
	cp '0'
	push hl
	call z, playB0b
	pop hl

	ld a, (hl)
	cp '1'
	push hl
	call z, playB1b
	pop hl

	ld a, (hl)
	cp '2'
	push hl
	call z, playB2b
	pop hl
	
	ld a, (hl)
	cp '3'
	push hl
	call z, playB3b
	pop hl
	
	ld a, (looptimes)
	dec a
	cp 0
	ret z
	ld (looptimes), a
	
	jp bNotesLoop
	ret

getDuration:
	; length = duration * 2 * tone
	; duration = 0.5 * length * (tone/tone/tone) * 1000
	; if length = 25 then simplified to: 
	;	5000/tone
	ld (tone), hl
	ex de, hl
	ld hl, 12500
	call DivideHLByDE
	
	ld (duration), de
	ld a, e

	ret
	
DivideHLByDE:
	ld b, d
	ld c, e
	ld (tmp), bc
	or a
	ld bc, 0
DivideHLByDELoop:
	sbc hl, de
	jp c, DivideHLByDENext
	inc bc
	jp z, DivideHLByDENext
	jp DivideHLByDELoop
DivideHLByDENext:
	add hl, de
	ld d, b
	ld e, c
	call roundDE
	ret

tmp:
	.db 0,0

roundDE:
	add hl, hl
	ld bc, (tmp)
	ld a, c
	cp l
	jp nc, roundDENext
	inc de
roundDENext:
	ret

play: 
   	ld a, 2 
	out (0),a 
	ld hl, (tone) 
	call pause 
	ld a, 0 
	out (0),a 
	ld hl, (tone) 
	call pause 
	 
	ld hl, (duration) 
	dec hl 
	ld (duration), hl
	
	ld hl, (duration) 
	ld a, h
	cp 0
	jp nz,play
	ld a, l
	cp 0
	jp nz,play
	ret
	 
pause: 
   	dec hl 
	ld a, l 
	cp 0 
	jp nz, pauseloopcontinue 
	ld a, h 
	cp 0 
	jp nz,pauseloopcontinue 
	ret 
pauseloopcontinue: 
	jp pause 
	ret

looptimes:
	.db 0,0
	
kloop:
	.dw 1000
	
duration:
	.dw 10
	
tone:
	.dw 1000
_SKIPOVERNOTEMAN:

